#if !defined(_SEModule_h_inc_)
#define _SEModule_h_inc_

#include "SEModule_base.h"
#include <stdio.h> // files

class Module : public SEModule_base
{
public:
	Module(seaudioMasterCallback2 seaudioMaster, void *p_resvd1);
	~Module();

	static bool getModuleProperties (SEModuleProperties* properties); 
	virtual bool getPinProperties (long index, SEPinProperties* properties);
	void SE_CALLING_CONVENTION sub_process(long buffer_offset, long sampleFrames );
	void OnPlugStateChange(SEPin *pin);
	virtual void OnMidiData( unsigned long p_clock, unsigned long midi_msg, short pin_id);
	void open();
    //ralphs
	void SE_CALLING_CONVENTION myproc(long buffer_offset, long sampleFrames);
    void diag(char * melde);
private:
    short REC;	
    char *text_input;
	bool admin;
//
errno_t err2;
errno_t err;
FILE *smidifileout ;
FILE *textfile ;
bool isnew ;
bool waspause;
state_type in_stat;
   unsigned long start_time;
   unsigned long r_time;
   unsigned long r_midi;
   unsigned long pause_time; 
   unsigned long pause_start;
   unsigned long pause_end;

char path[400];
char full_path[400];
char smidi_filename[400];
char text_filename[400];
char text[400];

struct LL
{
char thisSEM[100];
};
struct BB
{
	char buffer[1000];
};

#define PN_MIDI_IN 0
#define PN_REC 1
#define PN_TEXT 2
#define PN_ADMIN 3

#define SYSTEM_MSG		        0xF0
#define NOTE_OFF                0x80
#define NOTE_ON                 0x90




#define MAX_FILENAME_LENGTH 400




};
#endif
